/*
 * WhoIsIt -- A program to play an announcement over the computer speakers, of an incoming caller.
 *
 * Copyright (C) 2004, Steve Murphy
 *
 * Steve Murphy <murf@e-tools.com>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 */



#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

#define LOCAL_AREACODE "307"

clean_string(char *s)
{
	int l = strlen(s);
	int i;
	for( i=l-1; i>=0; i--)
	{
		if( s[i] == ' ' || s[i] == '\t')
		{
			s[i] = 0;
		}
		else
		{
			break;
		}
	}
}


main(int argc,char **argv)
{
	char command[1024];
	char path[1024];
	char *CIDnum = argv[1];
	char *CIDnam = argv[2];
	FILE *f;
	int i, international=0;

	if( argc < 2)
	{
		printf("Usage: who-is-it <phone-number> \"<optional-callerid-name>\"\n");
		exit(1);
	}
	if( argc < 3 )
		CIDnam = "";
	clean_string(CIDnam);
	/* the number may or may not start with a 1. If it does, do the equiv of skipping it */
	if( CIDnum[0] == '1' ) /* if the number starts with a 1, it's US, and that's where this program assumes you are */
		CIDnum++;

	if( CIDnum[0] == '0' && CIDnum[1] == '1' && CIDnum[2] == '1' )
	{
		international = 1;
		CIDnum += 3;
		sprintf(command,"/usr/bin/play /var/lib/asterisk/sounds/CID-PLACES/international.gsm");
		system(command);
	}

#ifdef TESTING
	f = fopen("/tmp/whoisit","w");
	if( f )
	{
		fprintf(f,"argc: %d;  arg0=%s,  arg1=%s,  ", argc, argv[0], argv[1]);
		for( i=2; i< argc; i++ )
			fprintf(f,"arg%d=%s,  ", i, argv[i]);
		fprintf(f,"\n");
		fclose(f);
	}
#endif
	if( !strcasecmp( CIDnam,"Privacy Manager") )
	{
		sprintf(command,"/usr/bin/play /var/lib/asterisk/sounds/priv-unlisted.gsm");
		system(command);
	}
	sprintf(path,"/var/lib/asterisk/sounds/priv-callerintros/%s.gsm", CIDnum);
	
	if( access(path,F_OK) == 0 )
	{
		sprintf(command,"/usr/bin/play %s", path);
		system(command);
	}
	else
	{
		char areacode[4];
		char prefix[8];
		int i;

		
		if( international )
		{
			/* if the number started with 011, CIDnum now contains the remainder. */
			/* match the country code */
			for( i=1; i < 6; i++)
			{
				prefix[i-1] = CIDnum[i-1];
				prefix[i] = 0;
				sprintf(command,"/var/lib/asterisk/sounds/CID-PLACES/country-codes/%s.gsm", prefix);
				if( access(command,F_OK) == 0 )
				{
					sprintf(command,"/usr/bin/play /var/lib/asterisk/sounds/CID-PLACES/country-codes/%s.gsm",
						prefix);
				}
			}
		}
		else
		{
			strncpy(areacode,CIDnum, 3);
			areacode[3] = 0;
			
			for(i = 3; i< 6; i++)
				prefix[i-3] = CIDnum[i];
			prefix[3] = 0;
	
			system("/usr/bin/play /var/lib/asterisk/sounds/unknowncallerfrom.gsm");
			if( !strncmp(CIDnum,LOCAL_AREACODE,3) )
			{
				sprintf(path,"/var/lib/asterisk/sounds/CID-PLACES/%s/%s.gsm", areacode,prefix);
				if( access(path,F_OK) == 0 )
				{
					sprintf(command,"/usr/bin/play %s",path);
					system(command);
				}
				else
					system("/usr/bin/play /var/lib/asterisk/sounds/somewhereinstate.gsm");
			}
			else
			{
				sprintf(path,"/var/lib/asterisk/sounds/CID-PLACES/%s/%s.gsm", areacode,prefix);
				if( access(path,F_OK) == 0 )
				{
					sprintf(command,"/usr/bin/play %s",path);
					system(command);
				}
				else
				{
					sprintf(path,"/var/lib/asterisk/sounds/CID-PLACES/%s.gsm", areacode);
					if( access(path,F_OK) == 0 )
					{
						sprintf(command,"/usr/bin/play %s",path);
						system(command);
					}
					else
						system("/usr/bin/play /var/lib/asterisk/sounds/somewhereoutstate.gsm");
						
				}
			}
		}
		if( CIDnam && strlen(CIDnam) )
		{
			/* write the CIDname field to a file, and play the file via tts in festival */
			int pid1 = getpid();
			char bufx[5000],bufy[5000];
			FILE *festin;
			sprintf(bufx,"/tmp/CID.%d.festival.txt", pid1);
			festin = fopen(bufx,"w");
			if( festin )
			{
				fprintf(festin,"%s\n", CIDnam);
				fclose(festin);
				sprintf(bufy,"/usr/bin/festival --tts %s", bufx);
				system(bufy);
				unlink(bufx);
			}
		}	
	}

	exit(0);
}




